Attribute VB_Name = "Module1"
Global global_szServerName As String

'Windows API registry function prototypes used by GetLastAppStartedValue() below
Declare Function RegOpenKey Lib "advapi32" Alias "RegOpenKeyA" _
    (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" _
    (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
    ByRef lpType As Long, ByVal szData As String, ByRef lpcbData As Long) As Long


' Function which uses the Windows system registry to obtain a string value from a
' key that records the last started TIBCO application.  See the S-PLUS/Axum
' documentation for more information on "Using application names in client program scripts".
Function GetLastAppStartedValue(sValueName As String) As String
    GetLastAppStartedValue = ""
    
    Const HKEY_LOCAL_MACHINE = &H80000002
    Const ERROR_SUCCESS = 0&
    Const REG_SZ = (1)
    Const SZ_LASTAPPSTARTED_KEY = "Software\TIBCO\LastAppStarted"
    
    On Error GoTo HandleErrors
    
    Dim lOpenSuccess As Long, lQuerySuccess As Long, lCloseSuccess As Long
    Dim lSubKeyFound As Long
    lOpenSuccess = RegOpenKey(HKEY_LOCAL_MACHINE, SZ_LASTAPPSTARTED_KEY, lSubKeyFound)
    If (lOpenSuccess <> ERROR_SUCCESS) Then
        GoTo HandleErrors
    End If

    Dim sValueFound As String * 512
    Dim lValueTypeFound As Long, cbValueFound As Long
    lValueTypeFound = 0
    cbValueFound = 512
    lQuerySuccess = RegQueryValueEx( _
        lSubKeyFound, _
        sValueName, _
        0, _
        lValueTypeFound, _
        sValueFound, _
        cbValueFound)
    
    lCloseSuccess = RegCloseKey(lSubKeyFound)
    
    If (lQuerySuccess = ERROR_SUCCESS And lValueTypeFound = REG_SZ And cbValueFound > 0) Then
        GetLastAppStartedValue = Left(sValueFound, cbValueFound - 1)
        Exit Function
    End If

HandleErrors:
    MsgBox "This program failed to get the value " + _
           sValueName + " " + _
           "from the system registry key " + _
           "'HKEY_LOCAL_MACHINE\Software\TIBCO\LastAppStarted." + Chr$(13) + Chr$(10) + Chr$(13) + Chr$(10) + _
           "Please ensure that TIBCO Spotfire S+ has been started at least once before trying " + _
           "this program again."
End Function



