Attribute VB_Name = "Module1"
'Windows API registry function prototypes used by GetLastAppStartedValue() below
Declare Function RegOpenKey Lib "advapi32" Alias "RegOpenKeyA" _
    (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" _
    (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
    ByRef lpType As Long, ByVal szData As String, ByRef lpcbData As Long) As Long

' Function which uses the Windows system registry to obtain a string value from a
' key that records the last started TIBCO application.  See the S-PLUS/Axum
' documentation for more information on "Using application names in client program scripts".
Function GetLastAppStartedValue(sValueName As String) As String
    GetLastAppStartedValue = ""
    
    Const HKEY_LOCAL_MACHINE = &H80000002
    Const ERROR_SUCCESS = 0&
    Const REG_SZ = (1)
    Const SZ_LASTAPPSTARTED_KEY = "Software\TIBCO\LastAppStarted"
    
    On Error GoTo HandleErrors
    
    Dim lOpenSuccess As Long, lQuerySuccess As Long, lCloseSuccess As Long
    Dim lSubKeyFound As Long
    lOpenSuccess = RegOpenKey(HKEY_LOCAL_MACHINE, SZ_LASTAPPSTARTED_KEY, lSubKeyFound)
    If (lOpenSuccess <> ERROR_SUCCESS) Then
        GoTo HandleErrors
    End If

    Dim sValueFound As String * 512
    Dim lValueTypeFound As Long, cbValueFound As Long
    lValueTypeFound = 0
    cbValueFound = 512
    lQuerySuccess = RegQueryValueEx( _
        lSubKeyFound, _
        sValueName, _
        0, _
        lValueTypeFound, _
        sValueFound, _
        cbValueFound)
    
    lCloseSuccess = RegCloseKey(lSubKeyFound)
    
    If (lQuerySuccess = ERROR_SUCCESS And lValueTypeFound = REG_SZ And cbValueFound > 0) Then
        GetLastAppStartedValue = Left(sValueFound, cbValueFound - 1)
        Exit Function
    End If

HandleErrors:
    MsgBox "This program failed to get the value " + _
           sValueName + " " + _
           "from the system registry key " + _
           "'HKEY_LOCAL_MACHINE\Software\TIBCO\LastAppStarted." + Chr$(13) + Chr$(10) + Chr$(13) + Chr$(10) + _
           "Please ensure that TIBCO Spotfire S+ has been started at least once before trying " + _
           "this program again."
End Function


' Utility function to remove the embedded graph sheet from the
' OLE1 Visual Basic object on the form
Sub DeleteOLEObject()
    Dim pObject As Object
    
    On Error GoTo LErrReturn
    
    ' Get the embedded graph sheet object
    Set pObject = GSPagesForm.OLE1.object
    
    ' If the embedded graph sheet is valid, then nuke it
    If (IsObject(pObject)) Then
        GSPagesForm.OLE1.Delete
        GSPagesForm.OLE1.Update
    End If
LErrReturn:
End Sub



' Function used to get an S-PLUS/Axum child object from a parent object of a particular class type and
' by a particular name.  Child object is passed back as modified first parameter of function.
Function GetChildObject(ByRef pChild As Object, pParent As Object, sChildType As String, sChildName As String) As Boolean
    Dim sParentName As String
    Dim sChildPathName As String
    
    GetChildObject = False
    Set pChild = Nothing
    
    On Error GoTo LErrReturn
    
    ' Test whether incoming parent object is valid
    If (IsObject(pParent) = False) Then
        Exit Function
    End If
    
    ' Test for valid child class type name and child name
    If (Len(sChildType) <= 0 Or Len(sChildName) <= 0) Then
        Exit Function
    End If
    
    ' Get the S-PLUS/Axum name of the parent object
    sParentName = pParent.NewName
    
    ' Form the S-PLUS/Axum path name of the child object by taking the
    ' parent name and adding a path name delimiter (see S-PLUS/Axum help
    ' for more info on path names) and finally adding the child name
    ' specified.
    sChildPathName = Trim$(sParentName) + "$" + Trim$(sChildName)
    
    ' Try to get the child object by the path name
    Set pChild = pParent.GetObject(sChildType, sChildPathName)
    If (IsObject(pChild)) Then
        GetChildObject = True
    End If

LErrReturn:
End Function



