VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Example of Container() and Containees() methods"
   ClientHeight    =   4935
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   4590
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4935
   ScaleWidth      =   4590
   Begin VB.CommandButton Command1 
      Caption         =   "Create Two Arrows in a Graph in a GraphSheet"
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   4095
   End
   Begin VB.Frame Frame1 
      Caption         =   "Object Info"
      Height          =   3975
      Left            =   240
      TabIndex        =   0
      Top             =   720
      Width           =   4095
      Begin VB.TextBox ContainerOfContainee 
         BackColor       =   &H00C0C0C0&
         Height          =   285
         Left            =   240
         Locked          =   -1  'True
         TabIndex        =   9
         Top             =   3480
         Width           =   3615
      End
      Begin VB.ComboBox ContainerList 
         Height          =   315
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   5
         Top             =   1200
         Width           =   3615
      End
      Begin VB.ListBox ContaineeList 
         Height          =   1035
         Left            =   240
         TabIndex        =   4
         Top             =   2040
         Width           =   3615
      End
      Begin VB.TextBox GraphSheetName 
         BackColor       =   &H00C0C0C0&
         Height          =   285
         Left            =   2520
         Locked          =   -1  'True
         TabIndex        =   3
         Top             =   360
         Width           =   1335
      End
      Begin VB.Label Label4 
         Caption         =   "Container of Containee selected:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   3240
         Width           =   3615
      End
      Begin VB.Label Label3 
         Caption         =   "Containees in Container:"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   1800
         Width           =   3615
      End
      Begin VB.Label Label2 
         Caption         =   "Select Container:"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   960
         Width           =   3615
      End
      Begin VB.Label Label1 
         Caption         =   "GraphSheet Name Created:"
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   2175
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

    ' Create an S-PLUS application object
    Set pApp = CreateObject(GetLastAppStartedValue("ApplicationName") + ".Application")
    
    ' Now, create a graph sheet object
    Set pGraphSheet = pApp.CreateObject("GraphSheet")
    
    ' Create a 2D graph object as a child of the graph sheet just created.
    Set pGraph = pGraphSheet.CreateObject("Graph2D")
    
    ' Finally create two arrows as children of the 2D graph object just created.
    Set pArrow1 = pGraph.CreateObject("Arrow")
    Set pArrow2 = pGraph.CreateObject("Arrow")
    
    ' Get the name of the newly created graph sheet and set it in the protected
    ' edit control on the form.
    GraphSheetName.Text = pGraphSheet.NewName
    
    ' Clear the list control used to show containers and add the graph sheet
    ' path name and the 2D graph path name to this list. Use the ClassName() and PathName()
    ' methods on the two objects to get these strings.
    ContainerList.Clear
    ContainerList.AddItem "[" + pGraphSheet.ClassName() + "]" + pGraphSheet.PathName()
    ContainerList.AddItem "[" + pGraph.ClassName() + "]" + pGraph.PathName()
    
    ' Set the graph sheet path name as selected in the list
    ContainerList.ListIndex = 0
    
End Sub


Private Sub ContaineeList_Click()

    ' Get the selected string from the containee list control
    Dim sSelectedContainee As String
    sSelectedContainee = Trim$(ContaineeList.List(ContaineeList.ListIndex))
    If (Len(sSelectedContainee) <= 0) Then
        Exit Sub
    End If
    
    ' Parse the selected string from the containee list control to get
    ' the selected class name and path name for the object we want
    ' containees for
    Dim sSelectedClass As String
    Dim sSelectedPath As String
    sSelectedClass = Mid$(sSelectedContainee, 2)
    Dim nFoundRightBracket As Integer
    nFoundRightBracket = InStr(sSelectedClass, "]")
    If (nFoundRightBracket <= 1) Then
        Exit Sub
    End If
    sSelectedClass = Trim$(Left$(sSelectedClass, nFoundRightBracket - 1))
    nFoundRightBracket = InStr(sSelectedContainee, "]")
    sSelectedPath = Trim$(Mid$(sSelectedContainee, nFoundRightBracket + 1))
    If (Len(sSelectedClass) <= 0 Or Len(sSelectedPath) <= 0) Then
        Exit Sub
    End If
    
    ' Get the containee object given the class name and path name parsed above
    Dim pContainee As Object
    Set pContainee = pApp.GetObject(sSelectedClass, sSelectedPath)
        
    ' Get this containee object's container using the Container() method on the
    ' containee object
    Dim pContainer As Object
    Set pContainer = pContainee.Container()

    ' Set the ContainerOfContainee edit control to the class name and path name
    ' of this container object. Use the ClassName() and PathName() methods on the
    ' container object to get these strings.
    ContainerOfContainee.Text = "[" + pContainer.ClassName() + "]" + pContainer.PathName()

End Sub


Private Sub ContainerList_Click()

    ' Clear the containee list
    ContaineeList.Clear
    
    ' Clear the ContainerOfContainee edit field
    ContainerOfContainee.Text = ""
    
    ' Get the selected string from the container list
    Dim sSelectedContainer As String
    sSelectedContainer = Trim$(ContainerList.List(ContainerList.ListIndex))
    If (Len(sSelectedContainer) <= 0) Then
        Exit Sub
    End If
    
    ' Parse the selected string from the container list to get
    ' the selected class name and path name for the object we want
    ' to find containee objects for
    Dim sSelectedClass As String
    Dim sSelectedPath As String
    sSelectedClass = Mid$(sSelectedContainer, 2)
    Dim nFoundRightBracket As Integer
    nFoundRightBracket = InStr(sSelectedClass, "]")
    If (nFoundRightBracket <= 1) Then
        Exit Sub
    End If
    sSelectedClass = Trim$(Left$(sSelectedClass, nFoundRightBracket - 1))
    nFoundRightBracket = InStr(sSelectedContainer, "]")
    sSelectedPath = Trim$(Mid$(sSelectedContainer, nFoundRightBracket + 1))
    If (Len(sSelectedClass) <= 0 Or Len(sSelectedPath) <= 0) Then
        Exit Sub
    End If
    
    ' Get the container object given the class name and path name parsed above
    Dim pObject As Object
    Set pObject = pApp.GetObject(sSelectedClass, sSelectedPath)
    
    ' Try to get either Graph or Arrow containee objects for this container object
    ' using the Containees() method on the container object found above
    Dim pContainees As Variant
    pContainees = pObject.Containees("Graph")
    If (IsEmpty(pContainees)) Then
        pContainees = pObject.Containees("Arrow")
    End If
    If (IsEmpty(pContainees)) Then
        Exit Sub
    End If
    
    ' Display the class names and path names of the containee objects found above
    ' in the ContaineeList control
    Dim lowerBound As Integer, upperBound As Integer
    lowerBound = LBound(pContainees)
    upperBound = UBound(pContainees)
    For i = lowerBound To upperBound
        Dim sContaineeClass As String, sContaineePath As String
        
        ' Use the ClassName() and PathName() methods on the containee object to
        ' return these strings
        sContaineeClass = pContainees(i).ClassName()
        sContaineePath = pContainees(i).PathName()
        
        ContaineeList.AddItem "[" + sContaineeClass + "]" + sContaineePath
    Next i

End Sub


