Attribute VB_Name = "Module1"
'Windows API registry function prototypes used by GetLastAppStartedValue() below
Declare Function RegOpenKey Lib "advapi32" Alias "RegOpenKeyA" _
    (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" _
    (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
    ByRef lpType As Long, ByVal szData As String, ByRef lpcbData As Long) As Long

' Function which uses the Windows system registry to obtain a string value from a
' key that records the last started TIBCO application.  See the S-PLUS/Axum
' documentation for more information on "Using application names in client program scripts".
Function GetLastAppStartedValue(sValueName As String) As String
    GetLastAppStartedValue = ""
    
    Const HKEY_LOCAL_MACHINE = &H80000002
    Const ERROR_SUCCESS = 0&
    Const REG_SZ = (1)
    Const SZ_LASTAPPSTARTED_KEY = "Software\TIBCO\LastAppStarted"
    
    On Error GoTo HandleErrors
    
    Dim lOpenSuccess As Long, lQuerySuccess As Long, lCloseSuccess As Long
    Dim lSubKeyFound As Long
    lOpenSuccess = RegOpenKey(HKEY_LOCAL_MACHINE, SZ_LASTAPPSTARTED_KEY, lSubKeyFound)
    If (lOpenSuccess <> ERROR_SUCCESS) Then
        GoTo HandleErrors
    End If

    Dim sValueFound As String * 512
    Dim lValueTypeFound As Long, cbValueFound As Long
    lValueTypeFound = 0
    cbValueFound = 512
    lQuerySuccess = RegQueryValueEx( _
        lSubKeyFound, _
        sValueName, _
        0, _
        lValueTypeFound, _
        sValueFound, _
        cbValueFound)
    
    lCloseSuccess = RegCloseKey(lSubKeyFound)
    
    If (lQuerySuccess = ERROR_SUCCESS And lValueTypeFound = REG_SZ And cbValueFound > 0) Then
        GetLastAppStartedValue = Left(sValueFound, cbValueFound - 1)
        Exit Function
    End If

HandleErrors:
    MsgBox "This program failed to get the value " + _
           sValueName + " " + _
           "from the system registry key " + _
           "'HKEY_LOCAL_MACHINE\Software\TIBCO\LastAppStarted." + Chr$(13) + Chr$(10) + Chr$(13) + Chr$(10) + _
           "Please ensure that TIBCO Spotfire S+ has been started at least once before trying " + _
           "this program again."
End Function


' Routine to delete an OLEObject from the form
Sub DeleteOLEObject()
    Dim pObject As Object
    
    On Error GoTo LERRReturn
    
    ' Get the actual object from the OLEObject and check for
    ' validity.  If valid, nuke the OLEObject (which nukes the
    ' actual embedded object as well)
    Set pObject = VBEmbed.OLE1.object
    If (IsObject(pObject)) Then
        VBEmbed.OLE1.Delete
    End If
    
LERRReturn:
End Sub



' Function to return a child object given a parent object, its class name, and object name
Function GetChildObject(ByRef pChild As Object, pParent As Object, sChildType As String, sChildName As String) As Boolean
    Dim sParentName As String
    Dim sChildPathName As String
    
    GetChildObject = False
    Set pChild = Nothing
    
    On Error GoTo LERRReturn
    
    ' Check for valid parent object
    If (IsObject(pParent) = False) Then
        Exit Function
    End If
    
    ' Check for valid child object class name and object name
    If (Len(sChildType) <= 0 Or Len(sChildName) <= 0) Then
        Exit Function
    End If
    
    ' Get the name of the parent object
    sParentName = pParent.NewName
    
    ' Form the pathname to the child object from the parent and child object names
    sChildPathName = Trim$(sParentName) + "$" + Trim$(sChildName)
    
    ' Try to get this child object from the parent
    Set pChild = pParent.GetObject(sChildType, sChildPathName)
    If (IsObject(pChild)) Then
        GetChildObject = True
    End If

LERRReturn:
End Function


' Routine to update the embedded object caption just below it on the form
' which records the file pathname on disk where the embedded object is saved.
Sub UpdateObjectPathName(sObjectPathName As String)
    VBEmbed.ObjectPathName.Caption = sObjectPathName
End Sub


