@echo off
setlocal enableextensions

set thisbasename=%~n0

set newworkflag=-newwork
set echoflag=-echo
set logspecified=no
set outspecified=no
set inputfile=
set inputbasefile=
set commandline=Splus.bat START
set bigdatacmdline=-nobigdata

:CMDLINESTART
if "%~1"=="" goto CMDLINEEND
set arg1=%~1
if "%arg1:~0,2%"=="--" set arg1=%arg1:~1%
if /i "%arg1%"=="-help" goto CMD_help
if /i "%~1"=="-j" goto CMDLINECONT
if /i "%arg1%"=="-logfile" goto CMD_logfile
if /i "%arg1%"=="-nologfile" goto CMD_nologfile
if /i "%arg1%"=="-noappendlog" goto CMD_noappendlog
if /i "%arg1%"=="-appendlog" goto CMD_appendlog
if /i "%arg1%"=="-input" goto CMD_input
if /i "%arg1%"=="-output" goto CMD_output
if /i "%arg1%"=="-work" goto CMD_work
if /i "%arg1%"=="-cwd" goto CMD_cwd
if /i "%arg1%"=="-newworkparent" goto CMD_newworkparent
if /i "%arg1%"=="-newwork" goto CMDLINECONT
if /i "%arg1%"=="-echo" goto CMD_echo
if /i "%arg1%"=="-noecho" goto CMD_noecho
if /i "%arg1%"=="-noclean" goto CMD_noclean
if /i "%arg1%"=="-background" goto CMD_background
if /i "%arg1%"=="-verbose" goto CMD_verbose
if /i "%arg1%"=="-noverbose" goto CMD_noverbose
if /i "%arg1%"=="-quitonerror" goto CMD_quitonerror
if /i "%arg1%"=="-noquitonerror" goto CMD_noquitonerror
if /i "%arg1%"=="-nobigdata" goto CMD_nobigdata
if /i "%arg1%"=="-bigdata" goto CMD_bigdata
if /i "%arg1%"=="-vanilla" goto CMD_vanilla
if /i "%arg1%"=="-console" goto CMD_console
if "%arg1:~0,1%"=="-" goto BadArgError
if "%~2"=="" goto CMD_inputlast
goto CMD_setenv
:CMDLINECONT
shift
goto CMDLINESTART
:CMDLINEEND
goto RUNSTEP

:CMD_help
	echo Arguments to SBATCH (all optional):
	echo   --help               
	echo			Print this message
	echo   -j                  
	echo			Enable java (not supported on Win32)
	echo   --cwd directory
	echo			Change to this directory before doing anything else
	echo   --input file         
	echo			Read input from inputfile
	echo			(or specify inputfile as last parameter)
	echo   --output file        
	echo			Send output to file
	echo			(default ^<basename inputfile^>.txt)
	echo   --logfile file       
	echo			Write session log to file
	echo			(default ^<basename inputfile^>.slg)
	echo			By ^<basename inputfile^> we mean inputfile
	echo			stripped of possible period and extension
	echo   --appendlog          
	echo			Append to log file (default is to overwrite)
	echo   --nologfile          
	echo			Do not make a session log
	echo   --work directory     
	echo			Use directory for working database (where=1),
	echo			making it if needed. If work is not specified
	echo			we will make new randomly named directory for
	echo			the working database
	echo   --noclean            
	echo			Do not remove that new randomly named directory
	echo			used for working database
	echo   --newworkparent directory 
	echo			Directory in which to make the new randomly named
	echo			working database
	echo   --echo               
	echo			Echo command lines to output (sets options(echo=T))
	echo			(this is the default)
	echo   --noecho             
	echo			Do not echo command lines to output
	echo			(sets options(echo=F))
	echo   --verbose            
	echo			Echo verbose logging information to output
	echo			(sets options(verbose=T))
	echo   --quitonerror        
	echo			Terminate immediately on engine error.
	echo			(Default: continue through errors)
	echo   --background         
	echo			Run S-PLUS in the background (returning immediately)
	echo   --vanilla            
	echo			Do not run user-defined startup scripts or functions
	echo			and set --newwork (--work is ignored)
	echo   --console            
	echo			Run only the console version, not the GUI.
	echo   --nobigdata            
	echo			Do not load the bigdata library when starting (the default action)
	echo   --bigdata         
	echo			Load the bigdata library when starting
	echo   name=value          
	echo			Will be added to environment so getenv('name')
	echo			returns 'value'
goto END

:CMD_setenv
if "%~2"=="" goto CMDLINECONT
set %1=%2
shift
goto CMDLINECONT

:CMD_j
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_logfile
if "%~2"=="" goto ExtraArgError
set commandline=%commandline% %1 %2
set logspecified=yes
shift
goto CMDLINECONT

:CMD_nologfile
set logspecified=yes
goto CMDLINECONT

:CMD_noappendlog
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_appendlog
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_input
if "%~2"=="" goto ExtraArgError
set commandline=%commandline% %1 %2
set inputfile=%~2
set inputbasefile=%~dpn2
shift
goto CMDLINECONT

:CMD_inputlast
set commandline=%commandline% -input %1
set inputfile=%~1
set inputbasefile=%~dpn1
shift
goto CMDLINECONT

:CMD_output
if "%~2"=="" goto ExtraArgError
set commandline=%commandline% %1 %2
set outspecified=yes
shift
goto CMDLINECONT

:CMD_cwd
if "%~2"=="" goto ExtraArgError
set commandline=%commandline% %1 %2
shift
goto CMDLINECONT

:CMD_work
if "%~2"=="" goto ExtraArgError
set commandline=%commandline% %1 %2
set newworkflag=
shift
goto CMDLINECONT

:CMD_newworkparent
if "%~2"=="" goto ExtraArgError
set commandline=%commandline% %1 %2
shift
goto CMDLINECONT

:CMD_echo
goto CMDLINECONT

:CMD_noecho
set echoflag=
goto CMDLINECONT

:CMD_console
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_noclean
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_background
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_verbose
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_noverbose
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_quitonerror
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_noquitonerror
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_nobigdata
set bigdatacmdline=
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_bigdata
set bigdatacmdline=
set commandline=%commandline% %1
goto CMDLINECONT

:CMD_vanilla
set commandline=%commandline% %1
goto CMDLINECONT

:RUNSTEP

cd

if "%inputfile%"=="" goto ErrorNoInputFile

set commandline=%commandline% %newworkflag% %echoflag% %bigdatacmdline%

if not "%logspecified%"=="yes" set commandline=%commandline% -logfile "%inputbasefile%.slg"
if not "%outspecified%"=="yes" set commandline=%commandline% -output "%inputbasefile%.txt"

if /i "%S_DEBUG%"=="yes" echo Will execute: %commandline%

call %commandline%

goto END

:BadArgError
echo Error in %thisbasename%: Illegal argument '%~1'.
goto END

:ExtraArgError
echo Error in %thisbasename%: Arg '%~1' option requires an extra argument.
goto END

:ErrorNoInputFile
echo Error in %thisbasename%: inputfile not specified.

:END
endlocal
