@echo off
setlocal enableextensions

set cwd=.
set work=
set BACKGROUND=
set S_LOGFILE_NEW=yes
set S_QUIT_ON_ERROR=
set S_NO_USER_INIT_FILES=
set S_ECHO=
set S_RDB_MAKE=
set S_RDB_PARENT=
set S_RDB_REMOVE=
set S_VERBOSE=
set use_console=
set S_LOAD_BIGDATA=yes
set S_SILENT_STARTUP=

:CMDLINESTART
if "%~1"=="" goto CMDLINEEND
if /i "%~1"=="-help" goto CMD_help
if /i "%~1"=="--help" goto CMD_help
if /i "%~1"=="-g" goto CMD_g
if /i "%~1"=="-j" goto CMD_j
if /i "%~1"=="-e" goto CMD_e
if /i "%~1"=="-logfile" goto CMD_logfile
if /i "%~1"=="--logfile" goto CMD_logfile
if /i "%~1"=="-nologfile" goto CMD_nologfile
if /i "%~1"=="--nologfile" goto CMD_nologfile
if /i "%~1"=="-noappendlog" goto CMD_noappendlog
if /i "%~1"=="--noappendlog" goto CMD_noappendlog
if /i "%~1"=="-appendlog" goto CMD_appendlog
if /i "%~1"=="--appendlog" goto CMD_appendlog
if /i "%~1"=="-input" goto CMD_input
if /i "%~1"=="--input" goto CMD_input
if /i "%~1"=="-output" goto CMD_output
if /i "%~1"=="--output" goto CMD_output
if /i "%~1"=="-work" goto CMD_work
if /i "%~1"=="--work" goto CMD_work
if /i "%~1"=="-cwd" goto CMD_cwd
if /i "%~1"=="--cwd" goto CMD_cwd
if /i "%~1"=="-newwork" goto CMD_newwork
if /i "%~1"=="--newwork" goto CMD_newwork
if /i "%~1"=="-newworkparent" goto CMD_newworkparent
if /i "%~1"=="--newworkparent" goto CMD_newworkparent
if /i "%~1"=="-background" goto CMD_background
if /i "%~1"=="--background" goto CMD_background
if /i "%~1"=="-echo" goto CMD_echo
if /i "%~1"=="--echo" goto CMD_echo
if /i "%~1"=="-noclean" goto CMD_noclean
if /i "%~1"=="--noclean" goto CMD_noclean
if /i "%~1"=="-verbose" goto CMD_verbose
if /i "%~1"=="--verbose" goto CMD_verbose
if /i "%~1"=="-noverbose" goto CMD_noverbose
if /i "%~1"=="--noverbose" goto CMD_noverbose
if /i "%~1"=="-quitonerror" goto CMD_quitonerror
if /i "%~1"=="--quitonerror" goto CMD_quitonerror
if /i "%~1"=="-noquitonerror" goto CMD_noquitonerror
if /i "%~1"=="--noquitonerror" goto CMD_noquitonerror
if /i "%~1"=="-vanilla" goto CMD_vanilla
if /i "%~1"=="--vanilla" goto CMD_vanilla
if /i "%~1"=="-console" goto CMD_console
if /i "%~1"=="--console" goto CMD_console
if /i "%~1"=="-bigdata" goto CMD_bigdata
if /i "%~1"=="--bigdata" goto CMD_bigdata
if /i "%~1"=="-nobigdata" goto CMD_nobigdata
if /i "%~1"=="--nobigdata" goto CMD_nobigdata
if /i "%~1"=="-exec" goto CMD_exec
if /i "%~1"=="--exec" goto CMD_exec
if /i "%~1"=="-quiet" goto CMD_quiet
if /i "%~1"=="--quiet" goto CMD_quiet
goto CMD_setenv
:CMDLINECONT
shift
goto CMDLINESTART
:CMDLINEEND
goto RUNSTEP

:CMD_help
	echo Arguments to START (all optional):
	echo   --help               
	echo			Print this message
	echo   -j                  
	echo			Enable java (not supported on Win32)
	echo   -e                  
	echo			Enable command line editing (not supported on Win32)
	echo   -g                  
	echo			Use java GUI (not supported on Win32)
	echo   --cwd directory		
	echo			Change to this directory before doing anything else
	echo   --input file         
	echo			Read input from file
	echo   --output file        
	echo			Send output to file
	echo   --logfile file       
	echo			Write session log to file
	echo   --appendlog				
	echo			Append to log file (default is to overwrite)
	echo   --work directory     
	echo			Use directory for working database (where=1),
	echo			making it if needed
	echo   --background         
	echo			Run S-PLUS in the background (returning immediately)
	echo   --newwork				
	echo			Make new, randomly named directory for working database
	echo   --noclean            
	echo			Do not remove that new randomly named directory
	echo			used for working database
	echo   --newworkparent directory
	echo			Directory in which to make the new randomly named
	echo			working database
	echo   --echo               
	echo			Echo command lines to output (sets options(echo=T))
	echo   --quiet
        echo                    Don't print startup messages
	echo   --verbose            
	echo			Echo verbose logging information to output
	echo			(sets options(verbose=T))
	echo   --quitonerror        
	echo			Terminate immediately on engine error.
	echo			(Default: continue through errors)
	echo   --vanilla            
	echo			Do not run user-defined startup scripts
	echo			or functions and set --newwork
	echo   --console            
	echo			Run only the console version, not the GUI.
	echo   --nobigdata            
	echo			Do not load the bigdata library when starting
	echo   --bigdata            
	echo			Load the bigdata library when starting (the default action)
	echo   --exec command [args]
	echo			Run the command, looking in SHOME\cmd for it first
	echo			No arguments after --exec command will be interpreted by START,
	echo			they will be passed to command.
	echo   name=value          
	echo			Will be added to environment so getenv('name')
	echo			returns 'value'
        echo The first hyphen in arguments of the form '--word' may be omitted
goto END

:CMD_setenv
if "%~2"=="" goto CMDLINECONT
set %1=%2
shift
goto CMDLINECONT

:CMD_g
echo Command line option -g is not supported on Win32 platforms.
goto CMDLINECONT
:CMD_j
echo Command line option -j is not supported on Win32 platforms.
goto CMDLINECONT
:CMD_e
echo Command line option -e is not supported on Win32 platforms.
goto CMDLINECONT

:CMD_logfile
shift
set S_LOGFILE=%~1
goto CMDLINECONT

:CMD_nologfile
shift
set S_LOGFILE=
goto CMDLINECONT

:CMD_noappendlog
set S_LOGFILE_NEW=yes
goto CMDLINECONT

:CMD_appendlog
set S_LOGFILE_NEW=no
goto CMDLINECONT

:CMD_input
shift
set S_BATCH_INPUT=%~1
goto CMDLINECONT

:CMD_output
shift
set S_BATCH_OUTPUT=%~1
goto CMDLINECONT

:CMD_quiet
set S_SILENT_STARTUP=yes
goto CMDLINECONT

:CMD_cwd
shift
set cwd=%~1
if not exist "%cwd%" goto ERR1
set S_RDB_PARENT=%cwd%
echo Changing into directory: %cwd%
%~d1
cd "%cwd%"
goto CMDLINECONT

:CMD_work
shift
set work=%~1
goto CMDLINECONT

:CMD_newwork
set S_RDB_MAKE=yes
goto CMDLINECONT

:CMD_newworkparent
shift
set S_RDB_PARENT=%~1
goto CMDLINECONT

:CMD_background
set BACKGROUND=yes
goto CMDLINECONT

:CMD_echo
set S_ECHO=yes
goto CMDLINECONT

:CMD_noclean
set S_RDB_REMOVE=no
goto CMDLINECONT

:CMD_verbose
set S_VERBOSE=yes
goto CMDLINECONT

:CMD_noverbose
set S_VERBOSE=no
goto CMDLINECONT

:CMD_quitonerror
set S_QUIT_ON_ERROR=yes
goto CMDLINECONT

:CMD_noquitonerror
set S_QUIT_ON_ERROR=
goto CMDLINECONT

:CMD_console
set use_console=yes
goto CMDLINECONT

:CMD_bigdata
set S_LOAD_BIGDATA=yes
goto CMDLINECONT

:CMD_nobigdata
REM : see .First.Sys
set S_LOAD_BIGDATA=no
goto CMDLINECONT

:CMD_vanilla
set S_NO_USER_INIT_FILES=yes
REM : also do what -newwork does
set S_RDB_MAKE=yes
goto CMDLINECONT

:CMD_exec
shift
REM - Splus START -exec command arg1 arg2
REM - should execute the command, finding it using Splus's PATH
set execcmd=%1
shift
REM - echo cmd=%execcmd%, args are %1 %2 %3 %4 %5 %6 %7 %8 %9
call %execcmd% %1 %2 %3 %4 %5 %6 %7 %8 %9 
goto END

:RUNSTEP

REM - BUG: 30845 FIX
if not "%S_RDB_PARENT%"=="" goto SKIPSETCURDIR
cd > START_cd_tmp.bat
call "%SHOME%\cmd\CRDFormat.exe" "set S_RDB_PARENT={0}" "file:START_cd_tmp.bat" > START_tmp.bat
call START_tmp.bat
del START_cd_tmp.bat
del START_tmp.bat
:SKIPSETCURDIR

if "%S_BATCH_INPUT%"=="" goto SKIPINPUTCHECK
if not exist "%S_BATCH_INPUT%" goto ERR2
:SKIPINPUTCHECK
if "%S_BATCH_OUTPUT%"=="" goto SKIPOUTPUTCHECK
:SKIPOUTPUTCHECK
if "%S_LOGFILE%"=="" goto SKIPLOGCHECK
:SKIPLOGCHECK

if "%work%"=="" goto SKIPWORKSET
if not exist "%work%" set S_WORK_MADE_HERE=yes
CHAPTER -m -d "%work%"
set S_WORK=%work%
set S_DATA=%work%
:SKIPWORKSET

set BATCH_ARGS=
set WAIT_ARGS=/wait
if /i "%BACKGROUND%"=="yes" set WAIT_ARGS=

REM If cmd\SPLUS.exe is not there (which is true for the server),
REM   then use the console i.e. sqpe.exe:
if not exist "%SHOME%\cmd\SPLUS.exe" set use_console=yes

if /i "%use_console%"=="yes" goto SKIPGUI
if not "%S_BATCH_INPUT%"=="" set BATCH_ARGS=/NOSTARTUPDLGS /NOSTATUSDLGS /BATCH "%S_BATCH_INPUT%"
if not "%S_BATCH_OUTPUT%"=="" set BATCH_ARGS=%BATCH_ARGS% "%S_BATCH_OUTPUT%"
set SCOMMAND=start " " %WAIT_ARGS% splus.exe S_CWD="%cwd%" /MULTIPLEINSTANCES /NOSAVEREGPATHS /NOPREPSPROJ %BATCH_ARGS%
goto SKIPCONSOLE
:SKIPGUI
if not "%S_BATCH_INPUT%"=="" set BATCH_ARGS=/BATCH "%S_BATCH_INPUT%"
if not "%S_BATCH_OUTPUT%"=="" set BATCH_ARGS="%BATCH_ARGS% > "%S_BATCH_OUTPUT%" 2>&1"
set SCOMMAND=sqpe.exe %BATCH_ARGS%
:SKIPCONSOLE

echo %SCOMMAND%

REM - BUG: 29913 - removing this line to fix bug.
REM - if not "%cwd%"=="" set S_PROJ=%cwd%

if /i "%S_DEBUG%"=="yes" echo Will execute: %SCOMMAND%

if /i "%use_console%"=="yes" goto DOCONSOLE

%SCOMMAND%

goto END

:DOCONSOLE
set PRESQPE=
if /i "%BACKGROUND%"=="yes" set PRESQPE=start
if "%S_BATCH_INPUT%"=="" goto CONS1
if "%S_BATCH_OUTPUT%"=="" goto CONS2
sqpe.exe /BATCH "%S_BATCH_INPUT%" > "%S_BATCH_OUTPUT%"  2>&1
goto END
:CONS1
if "%S_BATCH_OUTPUT%"=="" %PRESQPE% sqpe.exe
if not "%S_BATCH_OUTPUT%"=="" sqpe.exe > "%S_BATCH_OUTPUT%" 2>&1
goto END
:CONS2
if "%S_BATCH_INPUT%"=="" %PRESQPE% sqpe.exe
if not "%S_BATCH_INPUT%"=="" %PRESQPE% sqpe.exe /BATCH "%S_BATCH_INPUT%"
goto END

:ERR1
echo The cwd specified '%cwd%' does not exist.
goto END

:ERR2
echo The input file '%S_BATCH_INPUT%' does not exist.
goto END

:END
endlocal
